#include <gtk/gtk.h>


/*
 * window : Init CList.
 */
void
on_clist_realize                       (GtkWidget       *widget,
                                        gpointer         user_data);

/*
 * window : Select row.
 */
void
on_clist_select_row                    (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

/*
 * window : Button press on row.
 *          Button 3 display Menu.
 *          dbClick -> Edit.
 */
gboolean
on_clist_button_press_event            (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

/*
 * menu : Menu contextuel.
 */
void
on_new_activate                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
void
on_edit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
void
on_erase_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
void
on_params_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

/*
 * params : Solde minlevel alert.
 */
void
on_spinbutton_alert_realize            (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_spinbutton_alert_changed            (GtkEditable     *editable,
                                        gpointer         user_data);
/* 
 * params : View/hide Description, Payment column.
 */
void
on_togglebutton_desc_realize           (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_togglebutton_desc_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_togglebutton_payment_realize        (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_togglebutton_payment_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);


/* 
 * window : About Gcpt2 ? 
 */
void
on_about_button_clicked                (GtkButton       *button,
                                        gpointer         user_data);


/* 
 * win_load : Load new file_cmpts.
 */
void
on_load_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);
void
on_loadfile_button_clicked             (GtkButton       *button,
                                        gpointer         user_data);
gboolean
on_pixmap_about_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data);

/* 
 * win_save : Save account.
 */
void
on_save_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);
void
on_saveas_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);


/*
 * window : Erase current operation.
 */
void
on_erase_button_clicked                (GtkButton       *button,
                                        gpointer         user_data);

/* 
 * new : AddNew operation.
 */
void
on_new_button_clicked                  (GtkButton       *button,
                                        gpointer         user_data);
void
on_accept_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);
void
on_new_realize                         (GtkWidget       *widget,
                                        gpointer         user_data);
/*
 * new : Update date.
 */
void
on_calendar_realize                    (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_calendar_day_selected               (GtkCalendar     *calendar,
                                        gpointer         user_data);
void
on_calendar_month_changed              (GtkCalendar     *calendar,
                                        gpointer         user_data);
void
on_calendar_next_year                  (GtkCalendar     *calendar,
                                        gpointer         user_data);
void
on_calendar_prev_year                  (GtkCalendar     *calendar,
                                        gpointer         user_data);
/*
 * new : Update amount.
 */
void
on_entry_amount_realize                (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_entry_amount_changed                (GtkEditable     *editable,
                                        gpointer         user_data);
/*
 * new : Update comments.
 */
void
on_entry_desc_realize                  (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_entry_desc_changed                  (GtkEditable     *editable,
                                        gpointer         user_data);

/*
 * new : Operation : credit/debit.
 */
void
on_radiobutton_credit_realize          (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_debit_realize           (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_credit_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_radiobutton_debit_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

/*
 * new : Money.
 */
void
on_radiobutton_euro_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_radiobutton_franc_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_radiobutton_other_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_entry_other_changed                 (GtkEditable     *editable,
                                        gpointer         user_data);

/*
 * new : Payment mode.
 */
void
on_radiobutton_cheque_realize          (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_spinbutton_cheque_realize           (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_card_realize            (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_transfer_realize        (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_cheque_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_spinbutton_cheque_changed           (GtkEditable     *editable,
                                        gpointer         user_data);
void
on_radiobutton_card_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_radiobutton_transfer_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

/* 
 * edit : Change operation.
 */
void
on_edit_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);
void
on_change_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);
void
on_edit_realize                        (GtkWidget       *widget,
                                        gpointer         user_data);
/*
 * edit : Update date.
 */
void
on_calendar_edit_realize               (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_calendar_edit_day_selected          (GtkCalendar     *calendar,
                                        gpointer         user_data);
void
on_calendar_edit_month_changed         (GtkCalendar     *calendar,
                                        gpointer         user_data);
void
on_calendar_edit_next_year             (GtkCalendar     *calendar,
                                        gpointer         user_data);
void
on_calendar_edit_prev_year             (GtkCalendar     *calendar,
                                        gpointer         user_data);
/*
 * edit : Update amount.
 */ 
void
on_entry_edit_amount_realize           (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_entry_edit_amount_changed           (GtkEditable     *editable,
                                        gpointer         user_data);
/* 
 * edit : Update description.
 */

void
on_entry_edit_desc_realize             (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_entry_edit_desc_changed             (GtkEditable     *editable,
                                        gpointer         user_data);
/*
 * edit : Update operation.
 */
void
on_radiobutton_edit_credit_realize     (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_edit_debit_realize      (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_edit_credit_toggled     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_radiobutton_edit_debit_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
/*
 * edit : Update Money.
 */
void
on_radiobutton_edit_euro_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_radiobutton_edit_franc_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_radiobutton_edit_other_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_entry_edit_other_changed            (GtkEditable     *editable,
                                        gpointer         user_data);
/*
 * edit : Update payment.
 */
void
on_radiobutton_edit_cheque_realize     (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_spinbutton_edit_cheque_realize      (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_edit_card_realize       (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_edit_transfer_realize   (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_radiobutton_edit_cheque_toggled     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_spinbutton_edit_cheque_changed      (GtkEditable     *editable,
                                        gpointer         user_data);
void
on_radiobutton_edit_card_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_radiobutton_edit_transfer_toggled   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);


/*
 * view : View savings/profits, balance of payments.
 */
void
on_view_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data);
void
on_clist_balance_realize               (GtkWidget       *widget,
                                        gpointer         user_data);
void
on_entry_solde_realize                 (GtkWidget       *widget,
                                        gpointer         user_data);



