/*
 * NE PAS EDITER CE FICHIER - il est gnr par Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget*
create_window (void)
{
  GtkWidget *window;
  GtkWidget *vpaned;
  GtkWidget *vbox;
  GtkWidget *hbox14;
  guint load_button_key;
  GtkWidget *load_button;
  GtkWidget *about_button;
  GtkWidget *scrolledwindow;
  GtkWidget *clist;
  GtkWidget *label_sdate;
  GtkWidget *label_date;
  GtkWidget *label_description;
  GtkWidget *label_chk;
  GtkWidget *label_credit;
  GtkWidget *label_debit;
  GtkWidget *label_total;
  GtkWidget *table;
  guint new_button_key;
  GtkWidget *new_button;
  guint edit_button_key;
  GtkWidget *edit_button;
  guint erase_button_key;
  GtkWidget *erase_button;
  guint button_quit_key;
  GtkWidget *button_quit;
  guint view_button_key;
  GtkWidget *view_button;
  guint saveas_button_key;
  GtkWidget *saveas_button;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (window, "window");
  gtk_object_set_data (GTK_OBJECT (window), "window", window);
  gtk_widget_set_usize (window, 655, 350);
  gtk_container_set_border_width (GTK_CONTAINER (window), 10);
  gtk_window_set_title (GTK_WINDOW (window), _("Gcpt2 - AccountsBook"));
  gtk_window_set_default_size (GTK_WINDOW (window), 655, 350);
  gtk_window_set_policy (GTK_WINDOW (window), FALSE, TRUE, TRUE);

  vpaned = gtk_vpaned_new ();
  gtk_widget_set_name (vpaned, "vpaned");
  gtk_widget_ref (vpaned);
  gtk_object_set_data_full (GTK_OBJECT (window), "vpaned", vpaned,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vpaned);
  gtk_container_add (GTK_CONTAINER (window), vpaned);
  gtk_paned_set_position (GTK_PANED (vpaned), 275);

  vbox = gtk_vbox_new (FALSE, 9);
  gtk_widget_set_name (vbox, "vbox");
  gtk_widget_ref (vbox);
  gtk_object_set_data_full (GTK_OBJECT (window), "vbox", vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox);
  gtk_paned_pack1 (GTK_PANED (vpaned), vbox, FALSE, TRUE);

  hbox14 = gtk_hbox_new (FALSE, 2);
  gtk_widget_set_name (hbox14, "hbox14");
  gtk_widget_ref (hbox14);
  gtk_object_set_data_full (GTK_OBJECT (window), "hbox14", hbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox14);
  gtk_box_pack_start (GTK_BOX (vbox), hbox14, FALSE, FALSE, 0);

  load_button = gtk_button_new_with_label ("");
  load_button_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (load_button)->child),
                                   _("_Load cmpts - to do one's account"));
  gtk_widget_add_accelerator (load_button, "clicked", accel_group,
                              load_button_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (load_button, "load_button");
  gtk_widget_ref (load_button);
  gtk_object_set_data_full (GTK_OBJECT (window), "load_button", load_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (load_button);
  gtk_box_pack_start (GTK_BOX (hbox14), load_button, TRUE, TRUE, 0);
  gtk_widget_set_usize (load_button, -2, 25);
  gtk_tooltips_set_tip (tooltips, load_button, _("Load new account file"), NULL);
  gtk_widget_add_accelerator (load_button, "clicked", accel_group,
                              GDK_l, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  about_button = gtk_button_new_with_label (_("About Gcpt2"));
  gtk_widget_set_name (about_button, "about_button");
  gtk_widget_ref (about_button);
  gtk_object_set_data_full (GTK_OBJECT (window), "about_button", about_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about_button);
  gtk_box_pack_start (GTK_BOX (hbox14), about_button, FALSE, FALSE, 0);
  gtk_widget_set_usize (about_button, 80, 25);
  gtk_tooltips_set_tip (tooltips, about_button, _("Gcpt, what is it ?"), NULL);

  scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow, "scrolledwindow");
  gtk_widget_ref (scrolledwindow);
  gtk_object_set_data_full (GTK_OBJECT (window), "scrolledwindow", scrolledwindow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow);
  gtk_box_pack_start (GTK_BOX (vbox), scrolledwindow, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist = gtk_clist_new (7);
  gtk_widget_set_name (clist, "clist");
  gtk_widget_ref (clist);
  gtk_object_set_data_full (GTK_OBJECT (window), "clist", clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist);
  gtk_container_add (GTK_CONTAINER (scrolledwindow), clist);
  gtk_clist_set_column_width (GTK_CLIST (clist), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist), 2, 160);
  gtk_clist_set_column_width (GTK_CLIST (clist), 3, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist), 4, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist), 5, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist), 6, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist));

  label_sdate = gtk_label_new (_("SDate"));
  gtk_widget_set_name (label_sdate, "label_sdate");
  gtk_widget_ref (label_sdate);
  gtk_object_set_data_full (GTK_OBJECT (window), "label_sdate", label_sdate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_sdate);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label_sdate);
  gtk_label_set_justify (GTK_LABEL (label_sdate), GTK_JUSTIFY_LEFT);

  label_date = gtk_label_new (_("Date"));
  gtk_widget_set_name (label_date, "label_date");
  gtk_widget_ref (label_date);
  gtk_object_set_data_full (GTK_OBJECT (window), "label_date", label_date,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_date);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label_date);
  gtk_label_set_justify (GTK_LABEL (label_date), GTK_JUSTIFY_LEFT);

  label_description = gtk_label_new (_("Description"));
  gtk_widget_set_name (label_description, "label_description");
  gtk_widget_ref (label_description);
  gtk_object_set_data_full (GTK_OBJECT (window), "label_description", label_description,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_description);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label_description);
  gtk_label_set_justify (GTK_LABEL (label_description), GTK_JUSTIFY_LEFT);

  label_chk = gtk_label_new (_("Payment"));
  gtk_widget_set_name (label_chk, "label_chk");
  gtk_widget_ref (label_chk);
  gtk_object_set_data_full (GTK_OBJECT (window), "label_chk", label_chk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_chk);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 3, label_chk);

  label_credit = gtk_label_new (_("Credit"));
  gtk_widget_set_name (label_credit, "label_credit");
  gtk_widget_ref (label_credit);
  gtk_object_set_data_full (GTK_OBJECT (window), "label_credit", label_credit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_credit);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 4, label_credit);
  gtk_label_set_justify (GTK_LABEL (label_credit), GTK_JUSTIFY_RIGHT);

  label_debit = gtk_label_new (_("Debit"));
  gtk_widget_set_name (label_debit, "label_debit");
  gtk_widget_ref (label_debit);
  gtk_object_set_data_full (GTK_OBJECT (window), "label_debit", label_debit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_debit);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 5, label_debit);
  gtk_label_set_justify (GTK_LABEL (label_debit), GTK_JUSTIFY_RIGHT);

  label_total = gtk_label_new (_("Total"));
  gtk_widget_set_name (label_total, "label_total");
  gtk_widget_ref (label_total);
  gtk_object_set_data_full (GTK_OBJECT (window), "label_total", label_total,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_total);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 6, label_total);
  gtk_label_set_justify (GTK_LABEL (label_total), GTK_JUSTIFY_RIGHT);

  table = gtk_table_new (1, 6, TRUE);
  gtk_widget_set_name (table, "table");
  gtk_widget_ref (table);
  gtk_object_set_data_full (GTK_OBJECT (window), "table", table,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table);
  gtk_paned_pack2 (GTK_PANED (vpaned), table, FALSE, FALSE);
  gtk_widget_set_usize (table, -2, 30);
  gtk_container_set_border_width (GTK_CONTAINER (table), 5);

  new_button = gtk_button_new_with_label ("");
  new_button_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (new_button)->child),
                                   _("_New"));
  gtk_widget_add_accelerator (new_button, "clicked", accel_group,
                              new_button_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (new_button, "new_button");
  gtk_widget_ref (new_button);
  gtk_object_set_data_full (GTK_OBJECT (window), "new_button", new_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_button);
  gtk_table_attach (GTK_TABLE (table), new_button, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (new_button, 105, 35);
  gtk_tooltips_set_tip (tooltips, new_button, _("New op"), NULL);
  gtk_widget_add_accelerator (new_button, "clicked", accel_group,
                              GDK_n, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  edit_button = gtk_button_new_with_label ("");
  edit_button_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (edit_button)->child),
                                   _("_Edit"));
  gtk_widget_add_accelerator (edit_button, "clicked", accel_group,
                              edit_button_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (edit_button, "edit_button");
  gtk_widget_ref (edit_button);
  gtk_object_set_data_full (GTK_OBJECT (window), "edit_button", edit_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_button);
  gtk_table_attach (GTK_TABLE (table), edit_button, 1, 2, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (edit_button, 105, 35);
  gtk_tooltips_set_tip (tooltips, edit_button, _("Edit current op"), NULL);
  gtk_widget_add_accelerator (edit_button, "clicked", accel_group,
                              GDK_e, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  erase_button = gtk_button_new_with_label ("");
  erase_button_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (erase_button)->child),
                                   _("E_rase"));
  gtk_widget_add_accelerator (erase_button, "clicked", accel_group,
                              erase_button_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (erase_button, "erase_button");
  gtk_widget_ref (erase_button);
  gtk_object_set_data_full (GTK_OBJECT (window), "erase_button", erase_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (erase_button);
  gtk_table_attach (GTK_TABLE (table), erase_button, 2, 3, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (erase_button, 105, 35);
  gtk_tooltips_set_tip (tooltips, erase_button, _("Erase curent op"), NULL);
  gtk_widget_add_accelerator (erase_button, "clicked", accel_group,
                              GDK_r, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_add_accelerator (erase_button, "clicked", accel_group,
                              GDK_w, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_add_accelerator (erase_button, "clicked", accel_group,
                              GDK_Delete, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_add_accelerator (erase_button, "clicked", accel_group,
                              GDK_d, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  button_quit = gtk_button_new_with_label ("");
  button_quit_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (button_quit)->child),
                                   _("_Quit"));
  gtk_widget_add_accelerator (button_quit, "clicked", accel_group,
                              button_quit_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (button_quit, "button_quit");
  gtk_widget_ref (button_quit);
  gtk_object_set_data_full (GTK_OBJECT (window), "button_quit", button_quit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_quit);
  gtk_table_attach (GTK_TABLE (table), button_quit, 5, 6, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 2, 0);
  gtk_widget_set_usize (button_quit, 100, 35);
  gtk_widget_add_accelerator (button_quit, "clicked", accel_group,
                              GDK_q, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_add_accelerator (button_quit, "clicked", accel_group,
                              GDK_Escape, 0,
                              GTK_ACCEL_VISIBLE);

  view_button = gtk_button_new_with_label ("");
  view_button_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (view_button)->child),
                                   _("_Balance"));
  gtk_widget_add_accelerator (view_button, "clicked", accel_group,
                              view_button_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (view_button, "view_button");
  gtk_widget_ref (view_button);
  gtk_object_set_data_full (GTK_OBJECT (window), "view_button", view_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (view_button);
  gtk_table_attach (GTK_TABLE (table), view_button, 3, 4, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (view_button, 105, 35);
  gtk_tooltips_set_tip (tooltips, view_button, _("View savings/profits"), NULL);
  gtk_widget_add_accelerator (view_button, "clicked", accel_group,
                              GDK_b, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  saveas_button = gtk_button_new_with_label ("");
  saveas_button_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (saveas_button)->child),
                                   _("_Save as"));
  gtk_widget_add_accelerator (saveas_button, "clicked", accel_group,
                              saveas_button_key, GDK_MOD1_MASK, 0);
  gtk_widget_set_name (saveas_button, "saveas_button");
  gtk_widget_ref (saveas_button);
  gtk_object_set_data_full (GTK_OBJECT (window), "saveas_button", saveas_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (saveas_button);
  gtk_table_attach (GTK_TABLE (table), saveas_button, 4, 5, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (saveas_button, 105, 35);
  gtk_tooltips_set_tip (tooltips, saveas_button, _("Save accounts"), NULL);
  gtk_widget_add_accelerator (saveas_button, "clicked", accel_group,
                              GDK_s, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  gtk_signal_connect (GTK_OBJECT (load_button), "clicked",
                      GTK_SIGNAL_FUNC (on_load_button_clicked),
                      clist);
  gtk_signal_connect (GTK_OBJECT (about_button), "clicked",
                      GTK_SIGNAL_FUNC (on_about_button_clicked),
                      clist);
  gtk_signal_connect (GTK_OBJECT (clist), "realize",
                      GTK_SIGNAL_FUNC (on_clist_realize),
                      clist);
  gtk_signal_connect (GTK_OBJECT (clist), "select_row",
                      GTK_SIGNAL_FUNC (on_clist_select_row),
                      clist);
  gtk_signal_connect (GTK_OBJECT (clist), "button_press_event",
                      GTK_SIGNAL_FUNC (on_clist_button_press_event),
                      clist);
  gtk_signal_connect (GTK_OBJECT (new_button), "clicked",
                      GTK_SIGNAL_FUNC (on_new_button_clicked),
                      window);
  gtk_signal_connect (GTK_OBJECT (edit_button), "clicked",
                      GTK_SIGNAL_FUNC (on_edit_button_clicked),
                      window);
  gtk_signal_connect (GTK_OBJECT (erase_button), "clicked",
                      GTK_SIGNAL_FUNC (on_erase_button_clicked),
                      clist);
  gtk_signal_connect_object (GTK_OBJECT (button_quit), "clicked",
                             GTK_SIGNAL_FUNC (gtk_main_quit),
                             GTK_OBJECT (window));
  gtk_signal_connect (GTK_OBJECT (view_button), "clicked",
                      GTK_SIGNAL_FUNC (on_view_button_clicked),
                      clist);
  gtk_signal_connect (GTK_OBJECT (saveas_button), "clicked",
                      GTK_SIGNAL_FUNC (on_saveas_button_clicked),
                      clist);

  gtk_object_set_data (GTK_OBJECT (window), "tooltips", tooltips);

  gtk_window_add_accel_group (GTK_WINDOW (window), accel_group);

  return window;
}

GtkWidget*
create_win_load (void)
{
  GtkWidget *win_load;
  GtkWidget *load_button;
  GtkWidget *cancel_button;

  win_load = gtk_file_selection_new (_("Gcpt - Select new File"));
  gtk_widget_set_name (win_load, "win_load");
  gtk_object_set_data (GTK_OBJECT (win_load), "win_load", win_load);
  gtk_container_set_border_width (GTK_CONTAINER (win_load), 10);

  load_button = GTK_FILE_SELECTION (win_load)->ok_button;
  gtk_widget_set_name (load_button, "load_button");
  gtk_object_set_data (GTK_OBJECT (win_load), "load_button", load_button);
  gtk_widget_show (load_button);
  GTK_WIDGET_SET_FLAGS (load_button, GTK_CAN_DEFAULT);

  cancel_button = GTK_FILE_SELECTION (win_load)->cancel_button;
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_object_set_data (GTK_OBJECT (win_load), "cancel_button", cancel_button);
  gtk_widget_show (cancel_button);
  GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (load_button), "clicked",
                      GTK_SIGNAL_FUNC (on_loadfile_button_clicked),
                      win_load);
  gtk_signal_connect_object (GTK_OBJECT (cancel_button), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (win_load));

  return win_load;
}

GtkWidget*
create_new (void)
{
  GtkWidget *new;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *vbox2;
  GtkWidget *label_title;
  GtkWidget *frame_op;
  GtkWidget *vbox3;
  GSList *operation_group = NULL;
  GtkWidget *radiobutton_credit;
  GtkWidget *radiobutton_debit;
  GtkWidget *frame3;
  GtkWidget *vbox4;
  GtkWidget *hbox3;
  GtkWidget *vbox6;
  GtkWidget *label_amount;
  GtkWidget *entry_amount;
  GtkWidget *frame_money;
  GtkWidget *vbox7;
  GSList *money_group = NULL;
  GtkWidget *radiobutton_euro;
  GtkWidget *radiobutton_franc;
  GtkWidget *hbox5;
  GtkWidget *radiobutton_other;
  GtkWidget *entry_other;
  GtkWidget *vbox5;
  GtkWidget *label_desc;
  GtkWidget *entry_desc;
  GtkWidget *calendar;
  GtkWidget *hbox2;
  GtkWidget *frame_payment;
  GtkWidget *vbox8;
  GtkWidget *hbox6;
  GSList *payment_group = NULL;
  GtkWidget *radiobutton_cheque;
  GtkObject *spinbutton_cheque_adj;
  GtkWidget *spinbutton_cheque;
  GtkWidget *radiobutton_card;
  GtkWidget *radiobutton_transfer;
  GtkWidget *table1;
  GtkWidget *cancel_button;
  GtkWidget *accept_button;

  new = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (new, "new");
  gtk_object_set_data (GTK_OBJECT (new), "new", new);
  gtk_widget_set_usize (new, 600, 400);
  gtk_window_set_title (GTK_WINDOW (new), _("Adding op in accounts"));
  gtk_window_set_default_size (GTK_WINDOW (new), 600, 400);
  gtk_window_set_policy (GTK_WINDOW (new), FALSE, FALSE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (new), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (new), vbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (new), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 5);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox2, "vbox2");
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (new), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, TRUE, TRUE, 0);

  label_title = gtk_label_new (_("To do one's account"));
  gtk_widget_set_name (label_title, "label_title");
  gtk_widget_ref (label_title);
  gtk_object_set_data_full (GTK_OBJECT (new), "label_title", label_title,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_title);
  gtk_box_pack_start (GTK_BOX (vbox2), label_title, FALSE, FALSE, 15);
  gtk_misc_set_padding (GTK_MISC (label_title), 0, 5);

  frame_op = gtk_frame_new (_("Operation"));
  gtk_widget_set_name (frame_op, "frame_op");
  gtk_widget_ref (frame_op);
  gtk_object_set_data_full (GTK_OBJECT (new), "frame_op", frame_op,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_op);
  gtk_box_pack_end (GTK_BOX (vbox2), frame_op, FALSE, FALSE, 0);
  gtk_widget_set_usize (frame_op, 40, -2);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox3, "vbox3");
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (new), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (frame_op), vbox3);

  radiobutton_credit = gtk_radio_button_new_with_label (operation_group, _("Credit"));
  operation_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_credit));
  gtk_widget_set_name (radiobutton_credit, "radiobutton_credit");
  gtk_widget_ref (radiobutton_credit);
  gtk_object_set_data_full (GTK_OBJECT (new), "radiobutton_credit", radiobutton_credit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_credit);
  gtk_box_pack_start (GTK_BOX (vbox3), radiobutton_credit, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (radiobutton_credit), 5);

  radiobutton_debit = gtk_radio_button_new_with_label (operation_group, _("Debit"));
  operation_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_debit));
  gtk_widget_set_name (radiobutton_debit, "radiobutton_debit");
  gtk_widget_ref (radiobutton_debit);
  gtk_object_set_data_full (GTK_OBJECT (new), "radiobutton_debit", radiobutton_debit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_debit);
  gtk_box_pack_start (GTK_BOX (vbox3), radiobutton_debit, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (radiobutton_debit), 5);

  frame3 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame3, "frame3");
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (new), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (hbox1), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 5);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox4, "vbox4");
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (new), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (frame3), vbox4);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox3, "hbox3");
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (new), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox3, TRUE, TRUE, 0);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox6, "vbox6");
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (new), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_box_pack_start (GTK_BOX (hbox3), vbox6, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox6), 5);

  label_amount = gtk_label_new (_("Amount :"));
  gtk_widget_set_name (label_amount, "label_amount");
  gtk_widget_ref (label_amount);
  gtk_object_set_data_full (GTK_OBJECT (new), "label_amount", label_amount,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_amount);
  gtk_box_pack_start (GTK_BOX (vbox6), label_amount, TRUE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_amount), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_amount), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label_amount), 0, 5);

  entry_amount = gtk_entry_new_with_max_length (16);
  gtk_widget_set_name (entry_amount, "entry_amount");
  gtk_widget_ref (entry_amount);
  gtk_object_set_data_full (GTK_OBJECT (new), "entry_amount", entry_amount,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_amount);
  gtk_box_pack_end (GTK_BOX (vbox6), entry_amount, FALSE, TRUE, 0);
  gtk_widget_set_usize (entry_amount, -2, 20);

  frame_money = gtk_frame_new (NULL);
  gtk_widget_set_name (frame_money, "frame_money");
  gtk_widget_ref (frame_money);
  gtk_object_set_data_full (GTK_OBJECT (new), "frame_money", frame_money,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_money);
  gtk_box_pack_start (GTK_BOX (hbox3), frame_money, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame_money), 5);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox7, "vbox7");
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (new), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_container_add (GTK_CONTAINER (frame_money), vbox7);

  radiobutton_euro = gtk_radio_button_new_with_label (money_group, _("Euro"));
  money_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_euro));
  gtk_widget_set_name (radiobutton_euro, "radiobutton_euro");
  gtk_widget_ref (radiobutton_euro);
  gtk_object_set_data_full (GTK_OBJECT (new), "radiobutton_euro", radiobutton_euro,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_euro);
  gtk_box_pack_start (GTK_BOX (vbox7), radiobutton_euro, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (radiobutton_euro, FALSE);

  radiobutton_franc = gtk_radio_button_new_with_label (money_group, _("Franc"));
  money_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_franc));
  gtk_widget_set_name (radiobutton_franc, "radiobutton_franc");
  gtk_widget_ref (radiobutton_franc);
  gtk_object_set_data_full (GTK_OBJECT (new), "radiobutton_franc", radiobutton_franc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_franc);
  gtk_box_pack_start (GTK_BOX (vbox7), radiobutton_franc, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (radiobutton_franc, FALSE);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox5, "hbox5");
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (new), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox7), hbox5, FALSE, FALSE, 0);

  radiobutton_other = gtk_radio_button_new_with_label (money_group, _("Other"));
  money_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_other));
  gtk_widget_set_name (radiobutton_other, "radiobutton_other");
  gtk_widget_ref (radiobutton_other);
  gtk_object_set_data_full (GTK_OBJECT (new), "radiobutton_other", radiobutton_other,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_other);
  gtk_box_pack_start (GTK_BOX (hbox5), radiobutton_other, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (radiobutton_other, FALSE);

  entry_other = gtk_entry_new ();
  gtk_widget_set_name (entry_other, "entry_other");
  gtk_widget_ref (entry_other);
  gtk_object_set_data_full (GTK_OBJECT (new), "entry_other", entry_other,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_other);
  gtk_box_pack_start (GTK_BOX (hbox5), entry_other, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (entry_other, FALSE);
  gtk_entry_set_text (GTK_ENTRY (entry_other), _("Yens"));

  vbox5 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox5, "vbox5");
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (new), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (vbox4), vbox5, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox5), 5);

  label_desc = gtk_label_new (_("Comments :"));
  gtk_widget_set_name (label_desc, "label_desc");
  gtk_widget_ref (label_desc);
  gtk_object_set_data_full (GTK_OBJECT (new), "label_desc", label_desc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_desc);
  gtk_box_pack_start (GTK_BOX (vbox5), label_desc, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_desc), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_desc), 2.6077e-08, 0.5);

  entry_desc = gtk_entry_new ();
  gtk_widget_set_name (entry_desc, "entry_desc");
  gtk_widget_ref (entry_desc);
  gtk_object_set_data_full (GTK_OBJECT (new), "entry_desc", entry_desc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_desc);
  gtk_box_pack_start (GTK_BOX (vbox5), entry_desc, FALSE, FALSE, 0);
  gtk_widget_set_usize (entry_desc, -2, 25);

  calendar = gtk_calendar_new ();
  gtk_widget_set_name (calendar, "calendar");
  gtk_widget_ref (calendar);
  gtk_object_set_data_full (GTK_OBJECT (new), "calendar", calendar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (calendar);
  gtk_box_pack_start (GTK_BOX (vbox1), calendar, TRUE, TRUE, 0);
  gtk_calendar_display_options (GTK_CALENDAR (calendar),
                                GTK_CALENDAR_SHOW_HEADING
                                | GTK_CALENDAR_SHOW_DAY_NAMES);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (new), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 5);

  frame_payment = gtk_frame_new (_("Payment"));
  gtk_widget_set_name (frame_payment, "frame_payment");
  gtk_widget_ref (frame_payment);
  gtk_object_set_data_full (GTK_OBJECT (new), "frame_payment", frame_payment,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_payment);
  gtk_box_pack_start (GTK_BOX (hbox2), frame_payment, TRUE, TRUE, 0);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox8, "vbox8");
  gtk_widget_ref (vbox8);
  gtk_object_set_data_full (GTK_OBJECT (new), "vbox8", vbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox8);
  gtk_container_add (GTK_CONTAINER (frame_payment), vbox8);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox6, "hbox6");
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (new), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox8), hbox6, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox6), 5);

  radiobutton_cheque = gtk_radio_button_new_with_label (payment_group, _("Cheque number :"));
  payment_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_cheque));
  gtk_widget_set_name (radiobutton_cheque, "radiobutton_cheque");
  gtk_widget_ref (radiobutton_cheque);
  gtk_object_set_data_full (GTK_OBJECT (new), "radiobutton_cheque", radiobutton_cheque,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_cheque);
  gtk_box_pack_start (GTK_BOX (hbox6), radiobutton_cheque, FALSE, FALSE, 0);
  gtk_widget_set_usize (radiobutton_cheque, 150, -2);

  spinbutton_cheque_adj = gtk_adjustment_new (0, 0, 1e+09, 1, 100, 100);
  spinbutton_cheque = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_cheque_adj), 1, 0);
  gtk_widget_set_name (spinbutton_cheque, "spinbutton_cheque");
  gtk_widget_ref (spinbutton_cheque);
  gtk_object_set_data_full (GTK_OBJECT (new), "spinbutton_cheque", spinbutton_cheque,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_cheque);
  gtk_box_pack_start (GTK_BOX (hbox6), spinbutton_cheque, TRUE, TRUE, 0);

  radiobutton_card = gtk_radio_button_new_with_label (payment_group, _("Credit card"));
  payment_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_card));
  gtk_widget_set_name (radiobutton_card, "radiobutton_card");
  gtk_widget_ref (radiobutton_card);
  gtk_object_set_data_full (GTK_OBJECT (new), "radiobutton_card", radiobutton_card,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_card);
  gtk_box_pack_start (GTK_BOX (vbox8), radiobutton_card, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (radiobutton_card), 5);

  radiobutton_transfer = gtk_radio_button_new_with_label (payment_group, _("Bank transfer"));
  payment_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_transfer));
  gtk_widget_set_name (radiobutton_transfer, "radiobutton_transfer");
  gtk_widget_ref (radiobutton_transfer);
  gtk_object_set_data_full (GTK_OBJECT (new), "radiobutton_transfer", radiobutton_transfer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_transfer);
  gtk_box_pack_start (GTK_BOX (vbox8), radiobutton_transfer, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (radiobutton_transfer), 5);

  table1 = gtk_table_new (2, 1, FALSE);
  gtk_widget_set_name (table1, "table1");
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (new), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (hbox2), table1, TRUE, TRUE, 0);

  cancel_button = gtk_button_new_with_label (_("CanCel"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (new), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_table_attach (GTK_TABLE (table1), cancel_button, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (cancel_button), 10);

  accept_button = gtk_button_new_with_label (_("Accept"));
  gtk_widget_set_name (accept_button, "accept_button");
  gtk_widget_ref (accept_button);
  gtk_object_set_data_full (GTK_OBJECT (new), "accept_button", accept_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (accept_button);
  gtk_table_attach (GTK_TABLE (table1), accept_button, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_SHRINK | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (accept_button), 10);

  gtk_signal_connect (GTK_OBJECT (new), "realize",
                      GTK_SIGNAL_FUNC (on_new_realize),
                      new);
  gtk_signal_connect (GTK_OBJECT (radiobutton_credit), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_credit_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_credit), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_credit_realize),
                      radiobutton_credit);
  gtk_signal_connect (GTK_OBJECT (radiobutton_debit), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_debit_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_debit), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_debit_realize),
                      radiobutton_debit);
  gtk_signal_connect (GTK_OBJECT (entry_amount), "changed",
                      GTK_SIGNAL_FUNC (on_entry_amount_changed),
                      entry_amount);
  gtk_signal_connect (GTK_OBJECT (entry_amount), "realize",
                      GTK_SIGNAL_FUNC (on_entry_amount_realize),
                      entry_amount);
  gtk_signal_connect (GTK_OBJECT (radiobutton_euro), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_euro_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_franc), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_franc_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_other), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_other_toggled),
                      entry_other);
  gtk_signal_connect (GTK_OBJECT (entry_other), "changed",
                      GTK_SIGNAL_FUNC (on_entry_other_changed),
                      entry_other);
  gtk_signal_connect (GTK_OBJECT (entry_desc), "changed",
                      GTK_SIGNAL_FUNC (on_entry_desc_changed),
                      entry_desc);
  gtk_signal_connect (GTK_OBJECT (entry_desc), "realize",
                      GTK_SIGNAL_FUNC (on_entry_desc_realize),
                      entry_desc);
  gtk_signal_connect (GTK_OBJECT (calendar), "day_selected",
                      GTK_SIGNAL_FUNC (on_calendar_day_selected),
                      calendar);
  gtk_signal_connect (GTK_OBJECT (calendar), "month_changed",
                      GTK_SIGNAL_FUNC (on_calendar_month_changed),
                      calendar);
  gtk_signal_connect (GTK_OBJECT (calendar), "next_year",
                      GTK_SIGNAL_FUNC (on_calendar_next_year),
                      calendar);
  gtk_signal_connect (GTK_OBJECT (calendar), "prev_year",
                      GTK_SIGNAL_FUNC (on_calendar_prev_year),
                      calendar);
  gtk_signal_connect (GTK_OBJECT (calendar), "realize",
                      GTK_SIGNAL_FUNC (on_calendar_realize),
                      calendar);
  gtk_signal_connect (GTK_OBJECT (radiobutton_cheque), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_cheque_toggled),
                      spinbutton_cheque);
  gtk_signal_connect (GTK_OBJECT (radiobutton_cheque), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_cheque_realize),
                      radiobutton_cheque);
  gtk_signal_connect (GTK_OBJECT (spinbutton_cheque), "changed",
                      GTK_SIGNAL_FUNC (on_spinbutton_cheque_changed),
                      spinbutton_cheque);
  gtk_signal_connect (GTK_OBJECT (spinbutton_cheque), "realize",
                      GTK_SIGNAL_FUNC (on_spinbutton_cheque_realize),
                      spinbutton_cheque);
  gtk_signal_connect (GTK_OBJECT (radiobutton_card), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_card_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_card), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_card_realize),
                      radiobutton_card);
  gtk_signal_connect (GTK_OBJECT (radiobutton_transfer), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_transfer_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_transfer), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_transfer_realize),
                      radiobutton_transfer);
  gtk_signal_connect_object (GTK_OBJECT (cancel_button), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (new));
  gtk_signal_connect (GTK_OBJECT (accept_button), "clicked",
                      GTK_SIGNAL_FUNC (on_accept_button_clicked),
                      new);

  return new;
}

GtkWidget*
create_menu (void)
{
  GtkWidget *menu;
  GtkAccelGroup *menu_accels;
  guint tmp_key;
  GtkWidget *new;
  GtkWidget *edit;
  GtkWidget *erase;
  GtkWidget *s_parateur1;
  GtkWidget *params;
  GtkAccelGroup *accel_group;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  accel_group = gtk_accel_group_new ();

  menu = gtk_menu_new ();
  gtk_widget_set_name (menu, "menu");
  gtk_object_set_data (GTK_OBJECT (menu), "menu", menu);
  menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menu));

  new = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (new)->child),
                                   _("_New"));
  gtk_widget_add_accelerator (new, "activate_item", menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (new, "new");
  gtk_widget_ref (new);
  gtk_object_set_data_full (GTK_OBJECT (menu), "new", new,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new);
  gtk_container_add (GTK_CONTAINER (menu), new);
  gtk_tooltips_set_tip (tooltips, new, _("New op"), NULL);
  gtk_widget_add_accelerator (new, "activate", accel_group,
                              GDK_n, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  edit = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (edit)->child),
                                   _("_Edit"));
  gtk_widget_add_accelerator (edit, "activate_item", menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (edit, "edit");
  gtk_widget_ref (edit);
  gtk_object_set_data_full (GTK_OBJECT (menu), "edit", edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit);
  gtk_container_add (GTK_CONTAINER (menu), edit);
  gtk_tooltips_set_tip (tooltips, edit, _("Edit selected op"), NULL);
  gtk_widget_add_accelerator (edit, "activate", accel_group,
                              GDK_e, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  erase = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (erase)->child),
                                   _("_Erase"));
  gtk_widget_add_accelerator (erase, "activate_item", menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (erase, "erase");
  gtk_widget_ref (erase);
  gtk_object_set_data_full (GTK_OBJECT (menu), "erase", erase,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (erase);
  gtk_container_add (GTK_CONTAINER (menu), erase);
  gtk_tooltips_set_tip (tooltips, erase, _("Erase selected op"), NULL);
  gtk_widget_add_accelerator (erase, "activate", accel_group,
                              GDK_r, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  s_parateur1 = gtk_menu_item_new ();
  gtk_widget_set_name (s_parateur1, "s_parateur1");
  gtk_widget_ref (s_parateur1);
  gtk_object_set_data_full (GTK_OBJECT (menu), "s_parateur1", s_parateur1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (s_parateur1);
  gtk_container_add (GTK_CONTAINER (menu), s_parateur1);
  gtk_widget_set_sensitive (s_parateur1, FALSE);

  params = gtk_menu_item_new_with_label ("");
  tmp_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (params)->child),
                                   _("_Params"));
  gtk_widget_add_accelerator (params, "activate_item", menu_accels,
                              tmp_key, 0, 0);
  gtk_widget_set_name (params, "params");
  gtk_widget_ref (params);
  gtk_object_set_data_full (GTK_OBJECT (menu), "params", params,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (params);
  gtk_container_add (GTK_CONTAINER (menu), params);
  gtk_tooltips_set_tip (tooltips, params, _("Edit parameters"), NULL);
  gtk_widget_add_accelerator (params, "activate", accel_group,
                              GDK_p, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  gtk_signal_connect (GTK_OBJECT (new), "activate",
                      GTK_SIGNAL_FUNC (on_new_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (edit), "activate",
                      GTK_SIGNAL_FUNC (on_edit_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (erase), "activate",
                      GTK_SIGNAL_FUNC (on_erase_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (params), "activate",
                      GTK_SIGNAL_FUNC (on_params_activate),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (menu), "tooltips", tooltips);

  gtk_menu_set_accel_group (GTK_MENU (menu), accel_group);

  return menu;
}

GtkWidget*
create_win_save (void)
{
  GtkWidget *win_save;
  GtkWidget *save_button;
  GtkWidget *abort_button;

  win_save = gtk_file_selection_new (_("Gcpt - Select File to save as ..."));
  gtk_widget_set_name (win_save, "win_save");
  gtk_object_set_data (GTK_OBJECT (win_save), "win_save", win_save);
  gtk_container_set_border_width (GTK_CONTAINER (win_save), 10);

  save_button = GTK_FILE_SELECTION (win_save)->ok_button;
  gtk_widget_set_name (save_button, "save_button");
  gtk_object_set_data (GTK_OBJECT (win_save), "save_button", save_button);
  gtk_widget_show (save_button);
  GTK_WIDGET_SET_FLAGS (save_button, GTK_CAN_DEFAULT);

  abort_button = GTK_FILE_SELECTION (win_save)->cancel_button;
  gtk_widget_set_name (abort_button, "abort_button");
  gtk_object_set_data (GTK_OBJECT (win_save), "abort_button", abort_button);
  gtk_widget_show (abort_button);
  GTK_WIDGET_SET_FLAGS (abort_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_save_button_clicked),
                      win_save);
  gtk_signal_connect_object (GTK_OBJECT (abort_button), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (win_save));

  return win_save;
}

GtkWidget*
create_edit (void)
{
  GtkWidget *edit;
  GtkWidget *vbox9;
  GtkWidget *hbox7;
  GtkWidget *vbox10;
  GtkWidget *label_edit_title;
  GtkWidget *frame_edit_op;
  GtkWidget *vbox11;
  GSList *edit_operation_group = NULL;
  GtkWidget *radiobutton_edit_credit;
  GtkWidget *radiobutton_edit_debit;
  GtkWidget *frame5;
  GtkWidget *vbox12;
  GtkWidget *hbox8;
  GtkWidget *vbox13;
  GtkWidget *label_edit_amount;
  GtkWidget *entry_edit_amount;
  GtkWidget *frame_edit_money;
  GtkWidget *vbox14;
  GSList *edit_money_group = NULL;
  GtkWidget *radiobutton_edit_euro;
  GtkWidget *radiobutton_edit_franc;
  GtkWidget *hbox9;
  GtkWidget *radiobutton_edit_pther;
  GtkWidget *entry_edit_other;
  GtkWidget *vbox15;
  GtkWidget *label_edit_desc;
  GtkWidget *entry_edit_desc;
  GtkWidget *calendar_edit;
  GtkWidget *hbox10;
  GtkWidget *frame_edit_payment;
  GtkWidget *vbox16;
  GtkWidget *hbox11;
  GSList *edit_payment_group = NULL;
  GtkWidget *radiobutton_edit_cheque;
  GtkObject *spinbutton_edit_cheque_adj;
  GtkWidget *spinbutton_edit_cheque;
  GtkWidget *radiobutton_edit_card;
  GtkWidget *radiobutton_edit_transfer;
  GtkWidget *table2;
  GtkWidget *cancel_button;
  GtkWidget *change_button;

  edit = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (edit, "edit");
  gtk_object_set_data (GTK_OBJECT (edit), "edit", edit);
  gtk_widget_set_usize (edit, 600, 400);
  gtk_window_set_title (GTK_WINDOW (edit), _("Editing op in accounts"));
  gtk_window_set_default_size (GTK_WINDOW (edit), 600, 400);
  gtk_window_set_policy (GTK_WINDOW (edit), FALSE, FALSE, FALSE);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox9, "vbox9");
  gtk_widget_ref (vbox9);
  gtk_object_set_data_full (GTK_OBJECT (edit), "vbox9", vbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox9);
  gtk_container_add (GTK_CONTAINER (edit), vbox9);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox7, "hbox7");
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (edit), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox9), hbox7, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox7), 5);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox10, "vbox10");
  gtk_widget_ref (vbox10);
  gtk_object_set_data_full (GTK_OBJECT (edit), "vbox10", vbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox10);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox10, TRUE, TRUE, 0);

  label_edit_title = gtk_label_new (_("To do one's account"));
  gtk_widget_set_name (label_edit_title, "label_edit_title");
  gtk_widget_ref (label_edit_title);
  gtk_object_set_data_full (GTK_OBJECT (edit), "label_edit_title", label_edit_title,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_edit_title);
  gtk_box_pack_start (GTK_BOX (vbox10), label_edit_title, FALSE, FALSE, 15);
  gtk_misc_set_padding (GTK_MISC (label_edit_title), 0, 5);

  frame_edit_op = gtk_frame_new (_("Operation"));
  gtk_widget_set_name (frame_edit_op, "frame_edit_op");
  gtk_widget_ref (frame_edit_op);
  gtk_object_set_data_full (GTK_OBJECT (edit), "frame_edit_op", frame_edit_op,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_edit_op);
  gtk_box_pack_end (GTK_BOX (vbox10), frame_edit_op, FALSE, FALSE, 0);
  gtk_widget_set_usize (frame_edit_op, 40, -2);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox11, "vbox11");
  gtk_widget_ref (vbox11);
  gtk_object_set_data_full (GTK_OBJECT (edit), "vbox11", vbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox11);
  gtk_container_add (GTK_CONTAINER (frame_edit_op), vbox11);

  radiobutton_edit_credit = gtk_radio_button_new_with_label (edit_operation_group, _("Credit"));
  edit_operation_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_edit_credit));
  gtk_widget_set_name (radiobutton_edit_credit, "radiobutton_edit_credit");
  gtk_widget_ref (radiobutton_edit_credit);
  gtk_object_set_data_full (GTK_OBJECT (edit), "radiobutton_edit_credit", radiobutton_edit_credit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_edit_credit);
  gtk_box_pack_start (GTK_BOX (vbox11), radiobutton_edit_credit, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (radiobutton_edit_credit), 5);

  radiobutton_edit_debit = gtk_radio_button_new_with_label (edit_operation_group, _("Debit"));
  edit_operation_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_edit_debit));
  gtk_widget_set_name (radiobutton_edit_debit, "radiobutton_edit_debit");
  gtk_widget_ref (radiobutton_edit_debit);
  gtk_object_set_data_full (GTK_OBJECT (edit), "radiobutton_edit_debit", radiobutton_edit_debit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_edit_debit);
  gtk_box_pack_start (GTK_BOX (vbox11), radiobutton_edit_debit, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (radiobutton_edit_debit), 5);

  frame5 = gtk_frame_new (NULL);
  gtk_widget_set_name (frame5, "frame5");
  gtk_widget_ref (frame5);
  gtk_object_set_data_full (GTK_OBJECT (edit), "frame5", frame5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame5);
  gtk_box_pack_start (GTK_BOX (hbox7), frame5, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 5);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox12, "vbox12");
  gtk_widget_ref (vbox12);
  gtk_object_set_data_full (GTK_OBJECT (edit), "vbox12", vbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox12);
  gtk_container_add (GTK_CONTAINER (frame5), vbox12);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox8, "hbox8");
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (edit), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox12), hbox8, TRUE, TRUE, 0);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox13, "vbox13");
  gtk_widget_ref (vbox13);
  gtk_object_set_data_full (GTK_OBJECT (edit), "vbox13", vbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox13);
  gtk_box_pack_start (GTK_BOX (hbox8), vbox13, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox13), 5);

  label_edit_amount = gtk_label_new (_("Amount :"));
  gtk_widget_set_name (label_edit_amount, "label_edit_amount");
  gtk_widget_ref (label_edit_amount);
  gtk_object_set_data_full (GTK_OBJECT (edit), "label_edit_amount", label_edit_amount,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_edit_amount);
  gtk_box_pack_start (GTK_BOX (vbox13), label_edit_amount, TRUE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_edit_amount), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_edit_amount), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (label_edit_amount), 0, 5);

  entry_edit_amount = gtk_entry_new_with_max_length (16);
  gtk_widget_set_name (entry_edit_amount, "entry_edit_amount");
  gtk_widget_ref (entry_edit_amount);
  gtk_object_set_data_full (GTK_OBJECT (edit), "entry_edit_amount", entry_edit_amount,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_edit_amount);
  gtk_box_pack_end (GTK_BOX (vbox13), entry_edit_amount, FALSE, TRUE, 0);
  gtk_widget_set_usize (entry_edit_amount, -2, 20);

  frame_edit_money = gtk_frame_new (NULL);
  gtk_widget_set_name (frame_edit_money, "frame_edit_money");
  gtk_widget_ref (frame_edit_money);
  gtk_object_set_data_full (GTK_OBJECT (edit), "frame_edit_money", frame_edit_money,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_edit_money);
  gtk_box_pack_start (GTK_BOX (hbox8), frame_edit_money, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame_edit_money), 5);

  vbox14 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox14, "vbox14");
  gtk_widget_ref (vbox14);
  gtk_object_set_data_full (GTK_OBJECT (edit), "vbox14", vbox14,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox14);
  gtk_container_add (GTK_CONTAINER (frame_edit_money), vbox14);

  radiobutton_edit_euro = gtk_radio_button_new_with_label (edit_money_group, _("Euro"));
  edit_money_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_edit_euro));
  gtk_widget_set_name (radiobutton_edit_euro, "radiobutton_edit_euro");
  gtk_widget_ref (radiobutton_edit_euro);
  gtk_object_set_data_full (GTK_OBJECT (edit), "radiobutton_edit_euro", radiobutton_edit_euro,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_edit_euro);
  gtk_box_pack_start (GTK_BOX (vbox14), radiobutton_edit_euro, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (radiobutton_edit_euro, FALSE);

  radiobutton_edit_franc = gtk_radio_button_new_with_label (edit_money_group, _("Franc"));
  edit_money_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_edit_franc));
  gtk_widget_set_name (radiobutton_edit_franc, "radiobutton_edit_franc");
  gtk_widget_ref (radiobutton_edit_franc);
  gtk_object_set_data_full (GTK_OBJECT (edit), "radiobutton_edit_franc", radiobutton_edit_franc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_edit_franc);
  gtk_box_pack_start (GTK_BOX (vbox14), radiobutton_edit_franc, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (radiobutton_edit_franc, FALSE);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox9, "hbox9");
  gtk_widget_ref (hbox9);
  gtk_object_set_data_full (GTK_OBJECT (edit), "hbox9", hbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox14), hbox9, FALSE, FALSE, 0);

  radiobutton_edit_pther = gtk_radio_button_new_with_label (edit_money_group, _("Other"));
  edit_money_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_edit_pther));
  gtk_widget_set_name (radiobutton_edit_pther, "radiobutton_edit_pther");
  gtk_widget_ref (radiobutton_edit_pther);
  gtk_object_set_data_full (GTK_OBJECT (edit), "radiobutton_edit_pther", radiobutton_edit_pther,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_edit_pther);
  gtk_box_pack_start (GTK_BOX (hbox9), radiobutton_edit_pther, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (radiobutton_edit_pther, FALSE);

  entry_edit_other = gtk_entry_new ();
  gtk_widget_set_name (entry_edit_other, "entry_edit_other");
  gtk_widget_ref (entry_edit_other);
  gtk_object_set_data_full (GTK_OBJECT (edit), "entry_edit_other", entry_edit_other,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_edit_other);
  gtk_box_pack_start (GTK_BOX (hbox9), entry_edit_other, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (entry_edit_other, FALSE);
  gtk_entry_set_text (GTK_ENTRY (entry_edit_other), _("Yens"));

  vbox15 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox15, "vbox15");
  gtk_widget_ref (vbox15);
  gtk_object_set_data_full (GTK_OBJECT (edit), "vbox15", vbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox15);
  gtk_box_pack_start (GTK_BOX (vbox12), vbox15, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox15), 5);

  label_edit_desc = gtk_label_new (_("Comments :"));
  gtk_widget_set_name (label_edit_desc, "label_edit_desc");
  gtk_widget_ref (label_edit_desc);
  gtk_object_set_data_full (GTK_OBJECT (edit), "label_edit_desc", label_edit_desc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_edit_desc);
  gtk_box_pack_start (GTK_BOX (vbox15), label_edit_desc, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_edit_desc), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_edit_desc), 2.6077e-08, 0.5);

  entry_edit_desc = gtk_entry_new ();
  gtk_widget_set_name (entry_edit_desc, "entry_edit_desc");
  gtk_widget_ref (entry_edit_desc);
  gtk_object_set_data_full (GTK_OBJECT (edit), "entry_edit_desc", entry_edit_desc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_edit_desc);
  gtk_box_pack_start (GTK_BOX (vbox15), entry_edit_desc, FALSE, FALSE, 0);
  gtk_widget_set_usize (entry_edit_desc, -2, 25);

  calendar_edit = gtk_calendar_new ();
  gtk_widget_set_name (calendar_edit, "calendar_edit");
  gtk_widget_ref (calendar_edit);
  gtk_object_set_data_full (GTK_OBJECT (edit), "calendar_edit", calendar_edit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (calendar_edit);
  gtk_box_pack_start (GTK_BOX (vbox9), calendar_edit, TRUE, TRUE, 0);
  gtk_calendar_display_options (GTK_CALENDAR (calendar_edit),
                                GTK_CALENDAR_SHOW_HEADING
                                | GTK_CALENDAR_SHOW_DAY_NAMES);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox10, "hbox10");
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (edit), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox9), hbox10, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox10), 5);

  frame_edit_payment = gtk_frame_new (_("Payment"));
  gtk_widget_set_name (frame_edit_payment, "frame_edit_payment");
  gtk_widget_ref (frame_edit_payment);
  gtk_object_set_data_full (GTK_OBJECT (edit), "frame_edit_payment", frame_edit_payment,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_edit_payment);
  gtk_box_pack_start (GTK_BOX (hbox10), frame_edit_payment, TRUE, TRUE, 0);

  vbox16 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox16, "vbox16");
  gtk_widget_ref (vbox16);
  gtk_object_set_data_full (GTK_OBJECT (edit), "vbox16", vbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox16);
  gtk_container_add (GTK_CONTAINER (frame_edit_payment), vbox16);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox11, "hbox11");
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (edit), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox11);
  gtk_box_pack_start (GTK_BOX (vbox16), hbox11, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox11), 5);

  radiobutton_edit_cheque = gtk_radio_button_new_with_label (edit_payment_group, _("Cheque number :"));
  edit_payment_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_edit_cheque));
  gtk_widget_set_name (radiobutton_edit_cheque, "radiobutton_edit_cheque");
  gtk_widget_ref (radiobutton_edit_cheque);
  gtk_object_set_data_full (GTK_OBJECT (edit), "radiobutton_edit_cheque", radiobutton_edit_cheque,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_edit_cheque);
  gtk_box_pack_start (GTK_BOX (hbox11), radiobutton_edit_cheque, FALSE, FALSE, 0);
  gtk_widget_set_usize (radiobutton_edit_cheque, 150, -2);

  spinbutton_edit_cheque_adj = gtk_adjustment_new (0, 0, 1e+09, 1, 100, 100);
  spinbutton_edit_cheque = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_edit_cheque_adj), 1, 0);
  gtk_widget_set_name (spinbutton_edit_cheque, "spinbutton_edit_cheque");
  gtk_widget_ref (spinbutton_edit_cheque);
  gtk_object_set_data_full (GTK_OBJECT (edit), "spinbutton_edit_cheque", spinbutton_edit_cheque,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_edit_cheque);
  gtk_box_pack_start (GTK_BOX (hbox11), spinbutton_edit_cheque, TRUE, TRUE, 0);

  radiobutton_edit_card = gtk_radio_button_new_with_label (edit_payment_group, _("Credit card"));
  edit_payment_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_edit_card));
  gtk_widget_set_name (radiobutton_edit_card, "radiobutton_edit_card");
  gtk_widget_ref (radiobutton_edit_card);
  gtk_object_set_data_full (GTK_OBJECT (edit), "radiobutton_edit_card", radiobutton_edit_card,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_edit_card);
  gtk_box_pack_start (GTK_BOX (vbox16), radiobutton_edit_card, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (radiobutton_edit_card), 5);

  radiobutton_edit_transfer = gtk_radio_button_new_with_label (edit_payment_group, _("Bank transfer"));
  edit_payment_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_edit_transfer));
  gtk_widget_set_name (radiobutton_edit_transfer, "radiobutton_edit_transfer");
  gtk_widget_ref (radiobutton_edit_transfer);
  gtk_object_set_data_full (GTK_OBJECT (edit), "radiobutton_edit_transfer", radiobutton_edit_transfer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_edit_transfer);
  gtk_box_pack_start (GTK_BOX (vbox16), radiobutton_edit_transfer, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (radiobutton_edit_transfer), 5);

  table2 = gtk_table_new (2, 1, FALSE);
  gtk_widget_set_name (table2, "table2");
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (edit), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_box_pack_start (GTK_BOX (hbox10), table2, TRUE, TRUE, 0);

  cancel_button = gtk_button_new_with_label (_("CanCel"));
  gtk_widget_set_name (cancel_button, "cancel_button");
  gtk_widget_ref (cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (edit), "cancel_button", cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancel_button);
  gtk_table_attach (GTK_TABLE (table2), cancel_button, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (cancel_button), 10);

  change_button = gtk_button_new_with_label (_("Change"));
  gtk_widget_set_name (change_button, "change_button");
  gtk_widget_ref (change_button);
  gtk_object_set_data_full (GTK_OBJECT (edit), "change_button", change_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (change_button);
  gtk_table_attach (GTK_TABLE (table2), change_button, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_SHRINK | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (change_button), 10);

  gtk_signal_connect (GTK_OBJECT (edit), "realize",
                      GTK_SIGNAL_FUNC (on_edit_realize),
                      edit);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_credit), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_credit_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_credit), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_credit_realize),
                      radiobutton_edit_credit);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_debit), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_debit_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_debit), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_debit_realize),
                      radiobutton_edit_debit);
  gtk_signal_connect (GTK_OBJECT (entry_edit_amount), "changed",
                      GTK_SIGNAL_FUNC (on_entry_edit_amount_changed),
                      entry_edit_amount);
  gtk_signal_connect (GTK_OBJECT (entry_edit_amount), "realize",
                      GTK_SIGNAL_FUNC (on_entry_edit_amount_realize),
                      entry_edit_amount);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_euro), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_euro_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_franc), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_franc_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_pther), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_other_toggled),
                      entry_edit_other);
  gtk_signal_connect (GTK_OBJECT (entry_edit_other), "changed",
                      GTK_SIGNAL_FUNC (on_entry_edit_other_changed),
                      entry_edit_other);
  gtk_signal_connect (GTK_OBJECT (entry_edit_desc), "changed",
                      GTK_SIGNAL_FUNC (on_entry_edit_desc_changed),
                      entry_edit_desc);
  gtk_signal_connect (GTK_OBJECT (entry_edit_desc), "realize",
                      GTK_SIGNAL_FUNC (on_entry_edit_desc_realize),
                      entry_edit_desc);
  gtk_signal_connect (GTK_OBJECT (calendar_edit), "day_selected",
                      GTK_SIGNAL_FUNC (on_calendar_edit_day_selected),
                      calendar_edit);
  gtk_signal_connect (GTK_OBJECT (calendar_edit), "month_changed",
                      GTK_SIGNAL_FUNC (on_calendar_edit_month_changed),
                      calendar_edit);
  gtk_signal_connect (GTK_OBJECT (calendar_edit), "next_year",
                      GTK_SIGNAL_FUNC (on_calendar_edit_next_year),
                      calendar_edit);
  gtk_signal_connect (GTK_OBJECT (calendar_edit), "prev_year",
                      GTK_SIGNAL_FUNC (on_calendar_edit_prev_year),
                      calendar_edit);
  gtk_signal_connect (GTK_OBJECT (calendar_edit), "realize",
                      GTK_SIGNAL_FUNC (on_calendar_edit_realize),
                      calendar_edit);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_cheque), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_cheque_toggled),
                      spinbutton_edit_cheque);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_cheque), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_cheque_realize),
                      radiobutton_edit_cheque);
  gtk_signal_connect (GTK_OBJECT (spinbutton_edit_cheque), "changed",
                      GTK_SIGNAL_FUNC (on_spinbutton_edit_cheque_changed),
                      spinbutton_edit_cheque);
  gtk_signal_connect (GTK_OBJECT (spinbutton_edit_cheque), "realize",
                      GTK_SIGNAL_FUNC (on_spinbutton_edit_cheque_realize),
                      spinbutton_edit_cheque);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_card), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_card_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_card), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_card_realize),
                      radiobutton_edit_card);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_transfer), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_transfer_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radiobutton_edit_transfer), "realize",
                      GTK_SIGNAL_FUNC (on_radiobutton_edit_transfer_realize),
                      radiobutton_edit_transfer);
  gtk_signal_connect_object (GTK_OBJECT (cancel_button), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (edit));
  gtk_signal_connect (GTK_OBJECT (change_button), "clicked",
                      GTK_SIGNAL_FUNC (on_change_button_clicked),
                      edit);

  return edit;
}

GtkWidget*
create_options (void)
{
  GtkWidget *options;
  GtkWidget *hbox13;
  GtkWidget *frame_params;
  GtkWidget *table_params;
  GtkObject *spinbutton_alert_adj;
  GtkWidget *spinbutton_alert;
  GtkWidget *label_alert;
  GtkWidget *label_desc;
  GtkWidget *label_payment;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label5;
  GtkWidget *togglebutton_desc;
  GtkWidget *togglebutton_payment;
  GtkWidget *vbox19;
  GtkWidget *pixmap_gcpt;
  GtkWidget *button_ok;

  options = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (options, "options");
  gtk_object_set_data (GTK_OBJECT (options), "options", options);
  gtk_widget_set_usize (options, 230, 300);
  gtk_container_set_border_width (GTK_CONTAINER (options), 5);
  gtk_window_set_title (GTK_WINDOW (options), _("Edit parameters"));
  gtk_window_set_policy (GTK_WINDOW (options), TRUE, TRUE, TRUE);

  hbox13 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox13, "hbox13");
  gtk_widget_ref (hbox13);
  gtk_object_set_data_full (GTK_OBJECT (options), "hbox13", hbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox13);
  gtk_container_add (GTK_CONTAINER (options), hbox13);

  frame_params = gtk_frame_new (_("Parameters "));
  gtk_widget_set_name (frame_params, "frame_params");
  gtk_widget_ref (frame_params);
  gtk_object_set_data_full (GTK_OBJECT (options), "frame_params", frame_params,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_params);
  gtk_box_pack_start (GTK_BOX (hbox13), frame_params, TRUE, TRUE, 5);

  table_params = gtk_table_new (6, 2, TRUE);
  gtk_widget_set_name (table_params, "table_params");
  gtk_widget_ref (table_params);
  gtk_object_set_data_full (GTK_OBJECT (options), "table_params", table_params,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table_params);
  gtk_container_add (GTK_CONTAINER (frame_params), table_params);
  gtk_container_set_border_width (GTK_CONTAINER (table_params), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table_params), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table_params), 5);

  spinbutton_alert_adj = gtk_adjustment_new (0, -10000, 100000, 100, 1000, 1000);
  spinbutton_alert = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_alert_adj), 1, 2);
  gtk_widget_set_name (spinbutton_alert, "spinbutton_alert");
  gtk_widget_ref (spinbutton_alert);
  gtk_object_set_data_full (GTK_OBJECT (options), "spinbutton_alert", spinbutton_alert,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_alert);
  gtk_table_attach (GTK_TABLE (table_params), spinbutton_alert, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (spinbutton_alert, 100, -2);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_alert), TRUE);

  label_alert = gtk_label_new (_("Solde alert  < "));
  gtk_widget_set_name (label_alert, "label_alert");
  gtk_widget_ref (label_alert);
  gtk_object_set_data_full (GTK_OBJECT (options), "label_alert", label_alert,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_alert);
  gtk_table_attach (GTK_TABLE (table_params), label_alert, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (label_alert, 80, -2);
  gtk_label_set_justify (GTK_LABEL (label_alert), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_alert), 0, 0.5);

  label_desc = gtk_label_new (_("Description :"));
  gtk_widget_set_name (label_desc, "label_desc");
  gtk_widget_ref (label_desc);
  gtk_object_set_data_full (GTK_OBJECT (options), "label_desc", label_desc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_desc);
  gtk_table_attach (GTK_TABLE (table_params), label_desc, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (label_desc, 80, -2);
  gtk_label_set_justify (GTK_LABEL (label_desc), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_desc), 7.45058e-09, 0.5);

  label_payment = gtk_label_new (_("Payment :"));
  gtk_widget_set_name (label_payment, "label_payment");
  gtk_widget_ref (label_payment);
  gtk_object_set_data_full (GTK_OBJECT (options), "label_payment", label_payment,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_payment);
  gtk_table_attach (GTK_TABLE (table_params), label_payment, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (label_payment, 80, -2);
  gtk_label_set_justify (GTK_LABEL (label_payment), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_payment), 7.45058e-09, 0.5);

  label3 = gtk_label_new (_("label3 :"));
  gtk_widget_set_name (label3, "label3");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (options), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_table_attach (GTK_TABLE (table_params), label3, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (label3, 80, -2);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label3), 7.45058e-09, 0.5);

  label4 = gtk_label_new (_("label4 :"));
  gtk_widget_set_name (label4, "label4");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (options), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_table_attach (GTK_TABLE (table_params), label4, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (label4, 80, -2);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label4), 7.45058e-09, 0.5);

  label5 = gtk_label_new (_("label5 :"));
  gtk_widget_set_name (label5, "label5");
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (options), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table_params), label5, 0, 1, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_widget_set_usize (label5, 80, -2);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label5), 7.45058e-09, 0.5);

  togglebutton_desc = gtk_toggle_button_new_with_label (_("View / Hide"));
  gtk_widget_set_name (togglebutton_desc, "togglebutton_desc");
  gtk_widget_ref (togglebutton_desc);
  gtk_object_set_data_full (GTK_OBJECT (options), "togglebutton_desc", togglebutton_desc,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_desc);
  gtk_table_attach (GTK_TABLE (table_params), togglebutton_desc, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (togglebutton_desc), TRUE);

  togglebutton_payment = gtk_toggle_button_new_with_label (_("View / Hide"));
  gtk_widget_set_name (togglebutton_payment, "togglebutton_payment");
  gtk_widget_ref (togglebutton_payment);
  gtk_object_set_data_full (GTK_OBJECT (options), "togglebutton_payment", togglebutton_payment,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (togglebutton_payment);
  gtk_table_attach (GTK_TABLE (table_params), togglebutton_payment, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (togglebutton_payment), TRUE);

  vbox19 = gtk_vbox_new (FALSE, 5);
  gtk_widget_set_name (vbox19, "vbox19");
  gtk_widget_ref (vbox19);
  gtk_object_set_data_full (GTK_OBJECT (options), "vbox19", vbox19,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox19);
  gtk_box_pack_start (GTK_BOX (hbox13), vbox19, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox19, -2, 200);

  pixmap_gcpt = create_pixmap (options, "gcpt.xpm");
  gtk_widget_set_name (pixmap_gcpt, "pixmap_gcpt");
  gtk_widget_ref (pixmap_gcpt);
  gtk_object_set_data_full (GTK_OBJECT (options), "pixmap_gcpt", pixmap_gcpt,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap_gcpt);
  gtk_box_pack_start (GTK_BOX (vbox19), pixmap_gcpt, TRUE, TRUE, 0);

  button_ok = gtk_button_new_with_label (_("Ok"));
  gtk_widget_set_name (button_ok, "button_ok");
  gtk_widget_ref (button_ok);
  gtk_object_set_data_full (GTK_OBJECT (options), "button_ok", button_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok);
  gtk_box_pack_start (GTK_BOX (vbox19), button_ok, FALSE, FALSE, 0);
  gtk_widget_set_usize (button_ok, 30, 200);

  gtk_signal_connect (GTK_OBJECT (spinbutton_alert), "changed",
                      GTK_SIGNAL_FUNC (on_spinbutton_alert_changed),
                      spinbutton_alert);
  gtk_signal_connect (GTK_OBJECT (spinbutton_alert), "realize",
                      GTK_SIGNAL_FUNC (on_spinbutton_alert_realize),
                      spinbutton_alert);
  gtk_signal_connect (GTK_OBJECT (togglebutton_desc), "toggled",
                      GTK_SIGNAL_FUNC (on_togglebutton_desc_toggled),
                      togglebutton_desc);
  gtk_signal_connect (GTK_OBJECT (togglebutton_desc), "realize",
                      GTK_SIGNAL_FUNC (on_togglebutton_desc_realize),
                      togglebutton_desc);
  gtk_signal_connect (GTK_OBJECT (togglebutton_payment), "toggled",
                      GTK_SIGNAL_FUNC (on_togglebutton_payment_toggled),
                      togglebutton_payment);
  gtk_signal_connect (GTK_OBJECT (togglebutton_payment), "realize",
                      GTK_SIGNAL_FUNC (on_togglebutton_payment_realize),
                      togglebutton_payment);
  gtk_signal_connect_object (GTK_OBJECT (button_ok), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (options));

  return options;
}

GtkWidget*
create_balance (void)
{
  GtkWidget *balance;
  GtkWidget *vbox20;
  GtkWidget *frame_balance;
  GtkWidget *scrolledwindow1;
  GtkWidget *clist_balance;
  GtkWidget *label_months;
  GtkWidget *label_credits;
  GtkWidget *label_debits;
  GtkWidget *label_balance;
  GtkWidget *hbox15;
  GtkWidget *hbox16;
  GtkWidget *label_solde;
  GtkWidget *entry_solde;
  GtkWidget *vseparator1;
  GtkWidget *button_okquit;

  balance = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (balance, "balance");
  gtk_object_set_data (GTK_OBJECT (balance), "balance", balance);
  gtk_widget_set_usize (balance, 400, 300);
  gtk_container_set_border_width (GTK_CONTAINER (balance), 5);
  gtk_window_set_title (GTK_WINDOW (balance), _("Balance of payments"));
  gtk_window_set_policy (GTK_WINDOW (balance), TRUE, TRUE, TRUE);

  vbox20 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox20, "vbox20");
  gtk_widget_ref (vbox20);
  gtk_object_set_data_full (GTK_OBJECT (balance), "vbox20", vbox20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox20);
  gtk_container_add (GTK_CONTAINER (balance), vbox20);

  frame_balance = gtk_frame_new (_("Balance"));
  gtk_widget_set_name (frame_balance, "frame_balance");
  gtk_widget_ref (frame_balance);
  gtk_object_set_data_full (GTK_OBJECT (balance), "frame_balance", frame_balance,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_balance);
  gtk_box_pack_start (GTK_BOX (vbox20), frame_balance, TRUE, TRUE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (scrolledwindow1, "scrolledwindow1");
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (balance), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_container_add (GTK_CONTAINER (frame_balance), scrolledwindow1);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist_balance = gtk_clist_new (4);
  gtk_widget_set_name (clist_balance, "clist_balance");
  gtk_widget_ref (clist_balance);
  gtk_object_set_data_full (GTK_OBJECT (balance), "clist_balance", clist_balance,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist_balance);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist_balance);
  gtk_container_set_border_width (GTK_CONTAINER (clist_balance), 5);
  GTK_WIDGET_UNSET_FLAGS (clist_balance, GTK_CAN_FOCUS);
  gtk_clist_set_column_width (GTK_CLIST (clist_balance), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_balance), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_balance), 2, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_balance), 3, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist_balance));

  label_months = gtk_label_new ("");
  gtk_widget_set_name (label_months, "label_months");
  gtk_widget_ref (label_months);
  gtk_object_set_data_full (GTK_OBJECT (balance), "label_months", label_months,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_months);
  gtk_clist_set_column_widget (GTK_CLIST (clist_balance), 0, label_months);

  label_credits = gtk_label_new (_("Credits"));
  gtk_widget_set_name (label_credits, "label_credits");
  gtk_widget_ref (label_credits);
  gtk_object_set_data_full (GTK_OBJECT (balance), "label_credits", label_credits,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_credits);
  gtk_clist_set_column_widget (GTK_CLIST (clist_balance), 1, label_credits);
  gtk_label_set_justify (GTK_LABEL (label_credits), GTK_JUSTIFY_RIGHT);

  label_debits = gtk_label_new (_("Debits"));
  gtk_widget_set_name (label_debits, "label_debits");
  gtk_widget_ref (label_debits);
  gtk_object_set_data_full (GTK_OBJECT (balance), "label_debits", label_debits,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_debits);
  gtk_clist_set_column_widget (GTK_CLIST (clist_balance), 2, label_debits);
  gtk_label_set_justify (GTK_LABEL (label_debits), GTK_JUSTIFY_RIGHT);

  label_balance = gtk_label_new (_("Balance"));
  gtk_widget_set_name (label_balance, "label_balance");
  gtk_widget_ref (label_balance);
  gtk_object_set_data_full (GTK_OBJECT (balance), "label_balance", label_balance,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_balance);
  gtk_clist_set_column_widget (GTK_CLIST (clist_balance), 3, label_balance);
  gtk_label_set_justify (GTK_LABEL (label_balance), GTK_JUSTIFY_RIGHT);

  hbox15 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox15, "hbox15");
  gtk_widget_ref (hbox15);
  gtk_object_set_data_full (GTK_OBJECT (balance), "hbox15", hbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox15);
  gtk_box_pack_start (GTK_BOX (vbox20), hbox15, FALSE, FALSE, 0);
  gtk_widget_set_usize (hbox15, -2, 50);
  gtk_container_set_border_width (GTK_CONTAINER (hbox15), 5);

  hbox16 = gtk_hbox_new (FALSE, 5);
  gtk_widget_set_name (hbox16, "hbox16");
  gtk_widget_ref (hbox16);
  gtk_object_set_data_full (GTK_OBJECT (balance), "hbox16", hbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox16);
  gtk_box_pack_start (GTK_BOX (hbox15), hbox16, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox16), 5);

  label_solde = gtk_label_new (_("Solde :"));
  gtk_widget_set_name (label_solde, "label_solde");
  gtk_widget_ref (label_solde);
  gtk_object_set_data_full (GTK_OBJECT (balance), "label_solde", label_solde,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_solde);
  gtk_box_pack_start (GTK_BOX (hbox16), label_solde, FALSE, FALSE, 0);
  gtk_widget_set_usize (label_solde, 50, -2);
  gtk_label_set_justify (GTK_LABEL (label_solde), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_solde), 7.45058e-09, 0.5);

  entry_solde = gtk_entry_new ();
  gtk_widget_set_name (entry_solde, "entry_solde");
  gtk_widget_ref (entry_solde);
  gtk_object_set_data_full (GTK_OBJECT (balance), "entry_solde", entry_solde,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_solde);
  gtk_box_pack_start (GTK_BOX (hbox16), entry_solde, FALSE, FALSE, 0);
  gtk_widget_set_usize (entry_solde, 150, -2);
  gtk_entry_set_editable (GTK_ENTRY (entry_solde), FALSE);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_set_name (vseparator1, "vseparator1");
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (balance), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox15), vseparator1, FALSE, FALSE, 5);

  button_okquit = gtk_button_new_with_label (_("Ok / Quit"));
  gtk_widget_set_name (button_okquit, "button_okquit");
  gtk_widget_ref (button_okquit);
  gtk_object_set_data_full (GTK_OBJECT (balance), "button_okquit", button_okquit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_okquit);
  gtk_box_pack_start (GTK_BOX (hbox15), button_okquit, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button_okquit), 5);

  gtk_signal_connect (GTK_OBJECT (clist_balance), "realize",
                      GTK_SIGNAL_FUNC (on_clist_balance_realize),
                      clist_balance);
  gtk_signal_connect (GTK_OBJECT (entry_solde), "realize",
                      GTK_SIGNAL_FUNC (on_entry_solde_realize),
                      entry_solde);
  gtk_signal_connect_object (GTK_OBJECT (button_okquit), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (balance));

  return balance;
}

